package com.sun.media.sound;

import java.util.Arrays;

public final class ModelStandardDirector implements ModelDirector
{
    private final ModelPerformer[] performers;
    private final ModelDirectedPlayer player;
    private boolean noteOnUsed;
    private boolean noteOffUsed;
    
    public ModelStandardDirector(ModelPerformer[] original, ModelDirectedPlayer player) {
        this.noteOnUsed = false;
        this.noteOffUsed = false;
        this.performers = (ModelPerformer[])Arrays.copyOf(original, original.length);
        this.player = player;
        ModelPerformer[] performers = this.performers;
        for (int length = performers.length, i = 0; i < length; ++i) {
            if (performers[i].isReleaseTriggered()) {
                this.noteOffUsed = true;
            }
            else {
                this.noteOnUsed = true;
            }
        }
    }
    
    @Override
    public void close() {
    }
    
    @Override
    public void noteOff(int n, int n2) {
        if (!this.noteOffUsed) {
            return;
        }
        for (int i = 0; i < this.performers.length; ++i) {
            ModelPerformer modelPerformer = this.performers[i];
            if (modelPerformer.getKeyFrom() <= n && modelPerformer.getKeyTo() >= n && modelPerformer.getVelFrom() <= n2 && modelPerformer.getVelTo() >= n2 && modelPerformer.isReleaseTriggered()) {
                this.player.play(i, (ModelConnectionBlock[])null);
            }
        }
        return;
    }
    
    @Override
    public void noteOn(int n, int n2) {
        if (!this.noteOnUsed) {
            return;
        }
        for (int i = 0; i < this.performers.length; ++i) {
            ModelPerformer modelPerformer = this.performers[i];
            if (modelPerformer.getKeyFrom() <= n && modelPerformer.getKeyTo() >= n && modelPerformer.getVelFrom() <= n2 && modelPerformer.getVelTo() >= n2 && !modelPerformer.isReleaseTriggered()) {
                this.player.play(i, (ModelConnectionBlock[])null);
            }
        }
        return;
    }
}
